/* NSM Plug-In Interface (for Borland C++ Compiler) */

#ifndef NSM_PLUGIN_H
#define NSM_PLUGIN_H

#define NSM_API_VERSION "0.2.3"

// {IȌ^̒` --------------------------------------------------------------
	
typedef HANDLE HNsmService;
typedef HANDLE HNsmEvent;
typedef HANDLE HNsmConnection;
typedef HANDLE HNsmSession;

// ֐^̒` ------------------------------------------------------------------

typedef int (__stdcall *TNsmServiceProc)(WPARAM wParam, LPARAM lParam);
typedef int (__stdcall *TNsmEventProc)(WPARAM wParam, LPARAM lParam);

// {R[obN֐Q
typedef HNsmService (__stdcall *TCreateServiceProc)(LPCTSTR lpServiceName, TNsmServiceProc lpProcAddr);
typedef HNsmService (__stdcall *TGetServiceProc)(LPCTSTR lpServiceName);
typedef int (__stdcall *TCallServiceProc)(HNsmService hServiceHandle, WPARAM wParam, LPARAM lParam);
typedef HNsmEvent (__stdcall *TCreateEventProc)(LPCTSTR lpEventName);
typedef HNsmEvent (__stdcall *TGetEventProc)(LPCTSTR lpEventName);
typedef int (__stdcall *TNotifyEventProc)(HNsmEvent hEventHandle, WPARAM wParam, LPARAM lParam);
typedef int (__stdcall *THookEventProc)(LPCTSTR lpEventName, TNsmEventProc lpProcAddr);
typedef int (__stdcall *TUnhookEventProc)(LPCTSTR lpEventName, TNsmEventProc lpProcAddr);

// ̑̃R[obN֐
typedef int (__stdcall *TEnumConnectionCallback)(HNsmConnection hConnection, int nData);
typedef int (__stdcall *TEnumSessionCallback)(HNsmSession hSession, int nData);
typedef int (__stdcall *TEnumProtocolCallback)(LPTSTR lpProtocol, int nData);
typedef int (__stdcall *TEnumModuleCallback)(LPTSTR lpModuleName, int nData);
typedef int (__stdcall *TEnumMemberCallback)(LPTSTR lpAccount, int nData);
typedef int (__stdcall *TEnumGroupCallback)(int nGroupID, int nData);
typedef int (__stdcall *TEnumUIServiceCallback)(LPTSTR lpServiceName, int nData);
typedef void (__stdcall *TNotifyClickCallback)(int nData);

// \̂̒` ----------------------------------------------------------------
#pragma pack(push, 8)

// Initialize ֐œn̍\
typedef struct {
  int cbSize;
  TCreateServiceProc CreateService;
  TGetServiceProc GetService;
  TCallServiceProc CallService;
  TCreateEventProc CreateEvent;
  TGetEventProc GetEvent;
  TNotifyEventProc NotifyEvent;
  THookEventProc HookEvent;
  TUnhookEventProc UnhookEvent;
} TNsmPluginInitInfo, *PNsmPluginInitInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  LPCTSTR lpModuleName;               // W[
  int nInfoNo;                        // 擾ԍ
  LPTSTR lpBuffer;                    // i[obt@
  int nBufferSize;                    // obt@̑傫
} TNsmPluginInfo, *PNsmPluginInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  LPCTSTR lpAccount;                  // AJEg
  LPCTSTR lpPassword;                 // pX[h
  int nStatus;                        // [Ȕ
  LPCWSTR lpCaption;                  // ڑ̃LvV
}TLogInInfo, *PLogInInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nListKind;                      // R^NgXg̎
  int nFlags;                         // \
  TEnumMemberCallback lpCallBackProc; // R[obN֐
  int nData;                          // R[obN֐ɓnCӃf[^
} TEnumMemberInfo, *PEnumMemberInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nFlags;                         // \
  TEnumGroupCallback lpCallBackProc;  // R[obN֐
  int nData;                          // R[obN֐ɓnCӃf[^
} TEnumGroupInfo, *PEnumGroupInfo;

typedef struct {
  int nType;                          // ̌^
  LPBYTE lpBuffer;                    // i[obt@
  int nBufferSize;                    // obt@̃TCY
} TNsmInfo, *PNsmInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nListKind;                      // R^NgXg̎  	
  LPCTSTR lpAccount;                  // ݒ|擾õAJEg
  int nInfoKey;                       // 擾̃L[
  PNsmInfo lpInfo;                    // i[\̂ւ̃|C^
  int nFlags;                         // \
} TNsmMemberInfo, *PNsmMemberInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nGroupID;                       // ݒ|擾O[vID
  int nInfoKey;                       // 擾̃L[
  PNsmInfo lpInfo;                    // i[\̂ւ̃|C^
  int nFlags;                         // \
} TNsmGroupInfo, *PNsmGroupInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nListKind;                      // R^NgXg̎  	
  LPCTSTR lpAccount;                  // ݒ|擾õAJEg
} TAddMemberInfo, *PAddMemberInfo;

typedef TAddMemberInfo TRemoveMemberInfo;
typedef TAddMemberInfo *PAddMemberInfo;
typedef TAddMemberInfo *PRemoveMemberInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nInfoKey;                       // 擾̃L[
  PNsmInfo lpInfo;                    // i[\̂ւ̃|C^
} TNsmConnectionInfo, *PNsmConnectionInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nInfoKey;                       // 擾̃L[
  PNsmInfo lpInfo;                    // i[\̂ւ̃|C^
} TNsmSessionInfo, *PNsmSessionInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  HWND hWnd;                          // eEBhẼnhi0 ̏ꍇ͎ݒj
  LPCWSTR lpText;                     //
  LPCWSTR lpCaption;                  //
  DWORD uType;                        //
} TMessageBoxInfo, *PMessageBoxInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  LPCWSTR lpText;                     // \镶
  int nTimeToLive;                    // L\ԁibA0=ƕ\A-1=ftHglj
  int nIcon;                          // \ACR̎
  LPCWSTR lpLinkTo;                   // NbNƂɊJURL
  TNotifyClickCallback lpOnClick;     // NbNƂɌĂ΂R[obN֐
  int nData;                          // R[obN֐ɓnCӃf[^
} TNotifyInfo, *PNotifyInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  LPCTSTR lpToAccount;                // 
} TOpenSessionInfo, *POpenSessionInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  LPCWSTR lpFontName;                 // tHg
  int nCharSet;                       // LN^ZbgiShiftJIS = 128j
  int nFontSize;                      // TCYi|Cgj
  int nFontColor;                     // F
  int nBgColor;                       // wiF
  int nStyles;                        // tOiBold, Italic, etc...j
} TTextAttributeInfo, *PTextAttributeInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  LPCTSTR lpFrom;                     // olAJEgiM̏ꍇ NULL łj
  LPCWSTR lpBody;                     // bZ[W̖{iUNICODEj
  PTextAttributeInfo lpTextAttribute; // 
  int nFlags;                         // \
} TMessageInfo, *PMessageInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nStatus;                        // 
  LPCWSTR lpStatusStr;                // Ԃ\iNMST_CUSTOM ̎̂ݗLj
  int nBusyness;                      // ZiNMST_CUSTOM ̎̂ݗLj
} TUserStatusInfo, *PUserStatusInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  LPCWSTR lpName;                     // VO
} TUserNameInfo, *PUserNameInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  int nGroupId;                       // ΏۃO[vID
  LPCWSTR lpName;                     // VO[v
} TGroupNameInfo, *PGroupNameInfo;

typedef struct {
  int cbSize;                         // \̂̃TCY
  LPCTSTR lpAccount;                  // ΏۃoAJEg
  int nGroupId;                       // VO[vID
}TMemberGroupInfo, *PMemberGroupInfo;

typedef struct {
    int cbSize;                        // \̂̃TCY
    TEnumUIServiceCallback lpCallBackProc; // R[obN֐ւ̃|C^
    int nData;                         // R[obN֐ɓnf[^
    int nFlags;                        // \
} TEnumUIServiceInfo, *PEnumUIServiceInfo;

typedef struct {
    int cbSize;                        // \̂̃TCY
    int nInfoKey;                      // UIT[rXĂяoR(NMUI_XXXXŎw)
    int nGroupId;                      // O[vID
    LPCTSTR lpAccount;                 // AJEg
    PNsmInfo lpInfo;                   // ݒp
    int nFlags;                        // \
} TNsmUIServiceInfo, *PNsmUIServiceInfo;

typedef struct {
	int cbSize;                        // \̂̃TCY
	int nDataLen;                      // obt@TCY
	LPBYTE lpData;                     // f[^ǂݍރobt@
} TNsmFileIOData, *PNsmFileIOData;

typedef struct {
	int cbSize;                        // \̂̃TCY
	int nFileSize;                     // t@CTCY
} TNsmFileIOInfo, *PNsmFileIOInfo;

typedef struct {
	int cbSize;                        // \̂̃TCY
	LPCTSTR lpPluginName;              // vOC
	LPCTSTR lpSectionName;             // ZNV
	LPCTSTR lpMessageTag;              // ^O
	LPCTSTR lpDefaultStr;              // ftHg
	int nBufferSize;                   // obt@TCY
	LPBYTE lpBuffer;                   // obt@
} TNsmStrRsc, *PNsmStrRsc;

#pragma pack(pop)

// GNX|[g֐ --------------------------------------------------------
#ifdef __cplusplus
extern "C" {
#endif

int __declspec(dllexport) __stdcall GetPluginInfo(int nInfoNo, LPTSTR lpBuffer, int nSize);
int __declspec(dllexport) __stdcall Initialize(PNsmPluginInitInfo lpInitInfo);
int __declspec(dllexport) __stdcall Terminate();

#ifdef __cplusplus
}
#endif

// 萔̐錾 ------------------------------------------------------------------

// W[
#define NMM_SYSTEM          "System"
#define NMM_PROTOCOL        "Protocol"
#define NMM_UI              "UI"
#define NMM_ADDIN           "AddIn"

// T[rXECxg̃JeS
#define NMD_SYSTEM_CONNECTION                      NMM_SYSTEM "/Connection"
#define NMD_SYSTEM_CONNECTION_MEMBERS              NMD_SYSTEM_CONNECTION "/Members"
#define NMD_SYSTEM_CONNECTION_GROUPS               NMD_SYSTEM_CONNECTION "/Groups"
#define NMD_SYSTEM_CONNECTION_UISERVICE            NMD_SYSTEM_CONNECTION "/UIService"
#define NMD_SYSTEM_CONNECTION_UISERVICE_MAIN       NMD_SYSTEM_CONNECTION_UISERVICE "/Main"
#define NMD_SYSTEM_CONNECTION_UISERVICE_MEMBER     NMD_SYSTEM_CONNECTION_UISERVICE "/Member"
#define NMD_SYSTEM_CONNECTION_UISERVICE_GROUP      NMD_SYSTEM_CONNECTION_UISERVICE "/Group"
#define NMD_SYSTEM_SESSION                         NMM_SYSTEM "/Session"
#define NMD_SYSTEM_SESSION_MEMBERS                 NMD_SYSTEM_SESSION "/Members"
#define NMD_SYSTEM_ADDIN                           NMM_SYSTEM "/AddIn"
#define NMD_SYSTEM_ADDIN_UISERVICE                 NMD_SYSTEM_ADDIN "/UIService"
#define NMD_SYSTEM_ADDIN_UISERVICE_MAIN            NMD_SYSTEM_ADDIN_UISERVICE "/Main"
#define NMD_SYSTEM_ADDIN_UISERVICE_MEMBER          NMD_SYSTEM_ADDIN_UISERVICE "/Member"
#define NMD_SYSTEM_ADDIN_UISERVICE_GROUP           NMD_SYSTEM_ADDIN_UISERVICE "/Group"
#define NMD_SYSTEM_ADDIN_UISERVICE_TAB             NMD_SYSTEM_ADDIN_UISERVICE "/Tab"
#define NMD_PROTOCOL_CONNECTION                    NMM_PROTOCOL "/%s/Connection"
#define NMD_PROTOCOL_CONNECTION_UISERVICE          NMD_PROTOCOL_CONNECTION "/UIService"
#define NMD_PROTOCOL_CONNECTION_UISERVICE_MAIN     NMD_PROTOCOL_CONNECTION_UISERVICE "/Main"
#define NMD_PROTOCOL_CONNECTION_UISERVICE_MEMBER   NMD_PROTOCOL_CONNECTION_UISERVICE "/Member"
#define NMD_PROTOCOL_CONNECTION_UISERVICE_GROUP    NMD_PROTOCOL_CONNECTION_UISERVICE "/Group"
#define NMD_PROTOCOL_SESSION                       NMM_PROTOCOL "/%s/Session"
#define NMD_ADDIN_UISERVICE                        NMM_ADDIN "/%s/UIService"
#define NMD_ADDIN_UISERVICE_MAIN                   NMD_ADDIN_UISERVICE "/Main"
#define NMD_ADDIN_UISERVICE_MEMBER                 NMD_ADDIN_UISERVICE "/Member"
#define NMD_ADDIN_UISERVICE_GROUP                  NMD_ADDIN_UISERVICE "/Group"
#define NMD_ADDIN_UISERVICE_TAB                    NMD_ADDIN_UISERVICE "/Tab"
#define NMD_ADDIN_FILEIO                           NMM_ADDIN"/FileIO"
#define NMD_ADDIN_STRRSC                           NMM_ADDIN"/StrRsc"

// W[ʃT[rX
#define NMS_COMMON_SHOWOPTIONDIALOG                "%s/ShowOptionDialog"

// System Event
#define NME_SYSTEM_MODULESLOADED                    NMM_SYSTEM"/OnModulesLoaded"

#define NME_SYSTEM_CONNECTION_CONNECT               NMD_SYSTEM_CONNECTION"/OnConnect"
#define NME_SYSTEM_CONNECTION_DISCONNECT            NMD_SYSTEM_CONNECTION"/OnDisconnect"
#define NME_SYSTEM_CONNECTION_INFOCHANGE            NMD_SYSTEM_CONNECTION"/OnInfoChange"
#define NME_SYSTEM_CONNECTION_MEMBERS_ADD           NMD_SYSTEM_CONNECTION_MEMBERS"/OnAdd"
#define NME_SYSTEM_CONNECTION_MEMBERS_REMOVE        NMD_SYSTEM_CONNECTION_MEMBERS"/OnRemove"
#define NME_SYSTEM_CONNECTION_MEMBERS_INFOCHANGE    NMD_SYSTEM_CONNECTION_MEMBERS"/OnInfoChange"
#define NME_SYSTEM_CONNECTION_MEMBERS_INFOCHANGING  NMD_SYSTEM_CONNECTION_MEMBERS"/OnInfoChanging"
#define NME_SYSTEM_CONNECTION_GROUPS_ADD            NMD_SYSTEM_CONNECTION_GROUPS"/OnAdd"
#define NME_SYSTEM_CONNECTION_GROUPS_REMOVE         NMD_SYSTEM_CONNECTION_GROUPS"/OnRemove"
#define NME_SYSTEM_CONNECTION_GROUPS_INFOCHANGE     NMD_SYSTEM_CONNECTION_GROUPS"/OnInfoChange"

#define NME_SYSTEM_SESSION_OPEN                     NMD_SYSTEM_SESSION"/OnOpen"
#define NME_SYSTEM_SESSION_CLOSE                    NMD_SYSTEM_SESSION"/OnClose"
#define NME_SYSTEM_SESSION_INFOCHANGE               NMD_SYSTEM_SESSION"/OnInfoChange"
#define NME_SYSTEM_SESSION_SENDMESSAGE              NMD_SYSTEM_SESSION"/OnSendMessage"
#define NME_SYSTEM_SESSION_RECEIVEMESSAGE           NMD_SYSTEM_SESSION"/OnReceiveMessage"
#define NME_SYSTEM_SESSION_MEMBERS_ADD              NMD_SYSTEM_SESSION_MEMBERS"/OnAdd"
#define NME_SYSTEM_SESSION_MEMBERS_REMOVE           NMD_SYSTEM_SESSION_MEMBERS"/OnRemove"
#define NME_SYSTEM_SESSION_MEMBERS_INFOCHANGE       NMD_SYSTEM_SESSION_MEMBERS"/OnInfoChange"

// System Service
#define NMS_SYSTEM_EXIT                             NMM_SYSTEM"/Exit"
#define NMS_SYSTEM_DEBUG_PRINT                      NMM_SYSTEM"/Debug/Print"
#define NMS_SYSTEM_ENUMPROTOCOLS                    NMM_SYSTEM"/EnumProtocols"
#define NMS_SYSTEM_ENUMMODULES                      NMM_SYSTEM"/EnumModules"
#define NMS_SYSTEM_GETPLUGININFO                    NMM_SYSTEM"/GetPluginInfo"

#define NMS_SYSTEM_CONNECTION_CREATE                NMD_SYSTEM_CONNECTION"/Create"
#define NMS_SYSTEM_CONNECTION_DELETE                NMD_SYSTEM_CONNECTION"/Delete"
#define NMS_SYSTEM_CONNECTION_GETINFO               NMD_SYSTEM_CONNECTION"/GetInfo"
#define NMS_SYSTEM_CONNECTION_SETINFO               NMD_SYSTEM_CONNECTION"/SetInfo"
#define NMS_SYSTEM_CONNECTION_ENUM                  NMD_SYSTEM_CONNECTION"/Enum"

#define NMS_SYSTEM_CONNECTION_MEMBERS_ADD           NMD_SYSTEM_CONNECTION_MEMBERS"/Add"
#define NMS_SYSTEM_CONNECTION_MEMBERS_REMOVE        NMD_SYSTEM_CONNECTION_MEMBERS"/Remove"
#define NMS_SYSTEM_CONNECTION_MEMBERS_GETINFO       NMD_SYSTEM_CONNECTION_MEMBERS"/GetInfo"
#define NMS_SYSTEM_CONNECTION_MEMBERS_SETINFO       NMD_SYSTEM_CONNECTION_MEMBERS"/SetInfo"
#define NMS_SYSTEM_CONNECTION_MEMBERS_ENUM          NMD_SYSTEM_CONNECTION_MEMBERS"/Enum"
#define NMS_SYSTEM_CONNECTION_MEMBERS_BEGINUPDATE   NMD_SYSTEM_CONNECTION_MEMBERS"/BeginUpdate"
#define NMS_SYSTEM_CONNECTION_MEMBERS_ENDUPDATE     NMD_SYSTEM_CONNECTION_MEMBERS"/EndUpdate"

#define NMS_SYSTEM_CONNECTION_GROUPS_ADD            NMD_SYSTEM_CONNECTION_GROUPS"/Add"
#define NMS_SYSTEM_CONNECTION_GROUPS_REMOVE         NMD_SYSTEM_CONNECTION_GROUPS"/Remove"
#define NMS_SYSTEM_CONNECTION_GROUPS_GETINFO        NMD_SYSTEM_CONNECTION_GROUPS"/GetInfo"
#define NMS_SYSTEM_CONNECTION_GROUPS_SETINFO        NMD_SYSTEM_CONNECTION_GROUPS"/SetInfo"
#define NMS_SYSTEM_CONNECTION_GROUPS_ENUM           NMD_SYSTEM_CONNECTION_GROUPS"/Enum"
#define NMS_SYSTEM_CONNECTION_GROUPS_BEGINUPDATE    NMD_SYSTEM_CONNECTION_GROUPS"/BeginUpdate"
#define NMS_SYSTEM_CONNECTION_GROUPS_ENDUPDATE      NMD_SYSTEM_CONNECTION_GROUPS"/EndUpdate"

#define NMS_SYSTEM_SESSION_CREATE                   NMD_SYSTEM_SESSION"/Create"
#define NMS_SYSTEM_SESSION_DELETE                   NMD_SYSTEM_SESSION"/Delete"
#define NMS_SYSTEM_SESSION_GETINFO                  NMD_SYSTEM_SESSION"/GetInfo"
#define NMS_SYSTEM_SESSION_SETINFO                  NMD_SYSTEM_SESSION"/SetInfo"
#define NMS_SYSTEM_SESSION_ENUM                     NMD_SYSTEM_SESSION"/Enum"

#define NMS_SYSTEM_SESSION_MEMBERS_ADD              NMD_SYSTEM_SESSION_MEMBERS"/Add"
#define NMS_SYSTEM_SESSION_MEMBERS_REMOVE           NMD_SYSTEM_SESSION_MEMBERS"/Remove"
#define NMS_SYSTEM_SESSION_MEMBERS_GETINFO          NMD_SYSTEM_SESSION_MEMBERS"/GetInfo"
#define NMS_SYSTEM_SESSION_MEMBERS_SETINFO          NMD_SYSTEM_SESSION_MEMBERS"/SetInfo"
#define NMS_SYSTEM_SESSION_MEMBERS_ENUM             NMD_SYSTEM_SESSION_MEMBERS"/Enum"
#define NMS_SYSTEM_SESSION_MEMBERS_BEGINUPDATE      NMD_SYSTEM_SESSION_MEMBERS"/BeginUpdate"
#define NMS_SYSTEM_SESSION_MEMBERS_ENDUPDATE        NMD_SYSTEM_SESSION_MEMBERS"/EndUpdate"

#define NMS_SYSTEM_SESSION_SENDMESSAGE              NMD_SYSTEM_SESSION"/SendMessage"
#define NMS_SYSTEM_SESSION_RECEIVEMESSAGE           NMD_SYSTEM_SESSION"/ReceiveMessage"

#define NMS_SYSTEM_CONNECTION_UISERVICE_MAIN_ENUM   NMD_SYSTEM_CONNECTION_UISERVICE_MAIN "/Enum"
#define NMS_SYSTEM_CONNECTION_UISERVICE_MEMBER_ENUM NMD_SYSTEM_CONNECTION_UISERVICE_MEMBER "/Enum"
#define NMS_SYSTEM_CONNECTION_UISERVICE_GROUP_ENUM  NMD_SYSTEM_CONNECTION_UISERVICE_GROUP  "/Enum"

#define NMS_SYSTEM_ADDIN_UISERVICE_MAIN_ENUM        NMD_SYSTEM_ADDIN_UISERVICE_MAIN   "/Enum"
#define NMS_SYSTEM_ADDIN_UISERVICE_MEMBER_ENUM      NMD_SYSTEM_ADDIN_UISERVICE_MEMBER "/Enum"
#define NMS_SYSTEM_ADDIN_UISERVICE_GROUP_ENUM       NMD_SYSTEM_ADDIN_UISERVICE_GROUP  "/Enum"
#define NMS_SYSTEM_ADDIN_UISERVICE_TAB_ENUM         NMD_SYSTEM_ADDIN_UISERVICE_TAB    "/Enum"

// Protocol Service
#define NMS_PROTOCOL_CONNECTION_CONNECT             NMD_PROTOCOL_CONNECTION"/Connect"
#define NMS_PROTOCOL_CONNECTION_DISCONNECT          NMD_PROTOCOL_CONNECTION"/Disconnect"
#define NMS_PROTOCOL_CONNECTION_CHANGEUSERSTATUS    NMD_PROTOCOL_CONNECTION"/ChangeUserStatus"
#define NMS_PROTOCOL_CONNECTION_CHANGEUSERNAME      NMD_PROTOCOL_CONNECTION"/ChangeUserName"
#define NMS_PROTOCOL_CONNECTION_ADDMEMBER           NMD_PROTOCOL_CONNECTION"/AddMember"
#define NMS_PROTOCOL_CONNECTION_REMOVEMEMBER        NMD_PROTOCOL_CONNECTION"/RemoveMember"
#define NMS_PROTOCOL_CONNECTION_CHANGEMEMBERGROUP   NMD_PROTOCOL_CONNECTION"/ChangeMemberGroup"
#define NMS_PROTOCOL_CONNECTION_ADDGROUP            NMD_PROTOCOL_CONNECTION"/AddGroup"
#define NMS_PROTOCOL_CONNECTION_REMOVEGROUP         NMD_PROTOCOL_CONNECTION"/RemoveGroup"
#define NMS_PROTOCOL_CONNECTION_CHANGEGROUPNAME     NMD_PROTOCOL_CONNECTION"/ChangeGroupName"
#define NMS_PROTOCOL_CONNECTION_OPENMAIL            NMD_PROTOCOL_CONNECTION"/OpenMail"

#define NMS_PROTOCOL_SESSION_OPEN                   NMD_PROTOCOL_SESSION"/Open"
#define NMS_PROTOCOL_SESSION_CLOSE                  NMD_PROTOCOL_SESSION"/Close"
#define NMS_PROTOCOL_SESSION_INVITEMEMBER           NMD_PROTOCOL_SESSION"/InviteMember"
#define NMS_PROTOCOL_SESSION_SENDMESSAGE            NMD_PROTOCOL_SESSION"/SendMessage"
#define NMS_PROTOCOL_SESSION_BEGINTYPING            NMD_PROTOCOL_SESSION "/BeginTyping"
#define NMS_PROTOCOL_SESSION_ENDTYPING              NMD_PROTOCOL_SESSION "/EndTyping"

#define NMS_PROTOCOL_CONNECTION_UISERVICE_MAIN      NMD_PROTOCOL_CONNECTION_UISERVICE_MAIN"/%s"
#define NMS_PROTOCOL_CONNECTION_UISERVICE_MEMBER    NMD_PROTOCOL_CONNECTION_UISERVICE_MEMBER"/%s"
#define NMS_PROTOCOL_CONNECTION_UISERVICE_GROUP     NMD_PROTOCOL_CONNECTION_UISERVICE_GROUP"/%s"

// UI Service
#define NMS_UI_NOTIFY                               NMM_UI"/Notify"
#define NMS_UI_MESSAGEBOX                           NMM_UI"/MessageBox"

// AddIn Service
#define NMS_ADDIN_UISERVICE_MAIN                    NMD_ADDIN_UISERVICE_MAIN   "/%s"
#define NMS_ADDIN_UISERVICE_MEMBER                  NMD_ADDIN_UISERVICE_MEMBER "/%s"
#define NMS_ADDIN_UISERVICE_GROUP                   NMD_ADDIN_UISERVICE_GROUP  "/%s"
#define NMS_ADDIN_UISERVICE_TAB                     NMD_ADDIN_UISERVICE_TAB    "/%s"

// FileIO Service
#define NMS_ADDIN_FILEIO_OPEN                       NMD_ADDIN_FILEIO"/Open"
#define NMS_ADDIN_FILEIO_CREATE                     NMD_ADDIN_FILEIO"/Create"
#define NMS_ADDIN_FILEIO_READ                       NMD_ADDIN_FILEIO"/Read"
#define NMS_ADDIN_FILEIO_APPEND                     NMD_ADDIN_FILEIO"/Append"
#define NMS_ADDIN_FILEIO_CLOSE                      NMD_ADDIN_FILEIO"/Close"
#define NMS_ADDIN_FILEIO_GETINFO                    NMD_ADDIN_FILEIO"/GetInfo"
// StrRsc Service
#define NMS_ADDIN_STRRSC_GETLOCALSTR                NMD_ADDIN_STRRSC"/GetLocalStr"

// PluginInfo
#define NMPI_APIVER               0        // API ̃o[W
#define NMPI_MODULENAME           1        // W[
#define NMPI_TITLE                2        // vOC
#define NMPI_DESCRIPTION          3        // ȒPȐ
#define NMPI_AUTHOR               4        // 
#define NMPI_COPYRIGHT            5        // 쌠\
#define NMPI_PLUGINVER            6        // vOC̃o[W

// Xg̎
#define NMLK_FORWARDLIST          0        // R^NgXg
#define NMLK_REVERSELIST          1        // ΌXg
#define NMLK_ALLOWLIST            2        // Xg
#define NMLK_BLOCKLIST            3        // ֎~Xg

// o
#define NMMI_ACCOUNT              1000     // AJEg
#define NMMI_NAME                 1001     // \
#define NMMI_STATUS               1002     // 
#define NMMI_STATUSSTRING         1003     // Ԃ\
#define NMMI_BUSYNESS             1004     // Z(0..100)
#define NMMI_GROUPID              1005     // O[vID

// O[v
#define NMGI_ID                   1000     // O[vʎq
#define NMGI_NAME                 1001     // \
#define NMGI_EXPANDED             1002     // O[v̓WJ

// oݒtO
#define NMIF_INITLIST             2        // XglݒtO
#define NMIF_NOCHANGEEVENT        4        // OnInfoChange Cxg𔭐Ȃ
  
// RlNV
#define NMCI_USER_ACCOUNT         NMMI_ACCOUNT
#define NMCI_USER_NAME            NMMI_NAME
#define NMCI_USER_STATUS          NMMI_STATUS
#define NMCI_USER_STATUSSTRING    NMMI_STATUSSTRING
#define NMCI_USER_BUSYNESS        NMMI_BUSYNESS
#define NMCI_USER_MAILSTATUS      1007     // C̖ǐݒ

#define NMCI_PROTOCOL             2000     // vgRiǂݏopj
#define NMCI_CAPTION              2001     // LvV
#define NMCI_STATUS               2002     // ڑ

// ZbV
#define NMSI_CAPTION              1000     // LvV
#define NMSI_STATUS               1001     // ڑ
#define NMSI_CONNECTION           1002     // eRlNViǂݏopj
#define NMSI_PROTOCOL             1003     // vgRiǂݏopj

// ȍ
#define NMST_OFFLINE              0        // ItC
#define NMST_ONLINE               1        // IC
#define NMST_BUSY                 2        // 荞ݒ
#define NMST_IDLE                 3        // ACh
#define NMST_BERIGHTBACK          4        // ߂܂
#define NMST_AWAY                 5        // ސȒ
#define NMST_ONTHEPHONE           6        // db
#define NMST_OUTTOLUNCH           7        // x
#define NMST_HIDDEN               8        // s
#define NMST_CUSTOM               1000     // JX^

// ڑ̏
#define NMCS_DISCONNECTED         0        // ؒf
#define NMCS_CONNECTED            1        // ڑ
#define NMCS_CONNECTING           2        // ڑ
#define NMCS_DISCONNECTING        3        // ؒf

// ̌^
#define NMIT_STRING               0        // Ansi 
#define NMIT_WIDESTRING           1        // Unicode 
#define NMIT_INTEGER              2        // t32bitl
#define NMIT_BOOL                 3        // ^Ul

// ʒmACR
#define NMNI_EXCLAMATION           0       // x
#define NMNI_STOP                  1       // G[
#define NMNI_INFORMATION           2       // 
#define NMNI_QUESTION              3       // ₢킹
#define NMNI_MESSAGE               4       // bZ[WM
#define NMNI_MAIL                  5       // [M
#define NMNI_FILE                  6       // t@CM
#define NMNI_CONNECT               7       // ڑ
#define NMNI_DISCONNECT            8       // ؒf
#define NMNI_ONLINE                9       // oIC
#define NMNI_OFFLINE              10       // oItC
#define NMNI_BUSY                 11       // orW[

// 
#define NMFS_BOLD                  2       // 
#define NMFS_ITALIC                4       // Α
#define NMFS_UNDERLINE             8       // 
#define NMFS_STRIKEOUT            16       // 

// G[萔
#define NMP_ERROR_NOTIMPLEMENT     -1     // ĂȂ
#define NMP_ALLRIGHT                0     // I
#define NMP_ERROR_INTERNAL        100     // G[
#define NMP_ERROR_UNINITIALIZED   101     // vOCĂȂ

// UIT[rX
#define NMUI_GETCAPTION          0        // j[ڎ擾
#define NMUI_ONCLICK             1        // j[I

#endif  /* NSM_PLUGIN_H */
